/*
Copyright Rev'[evolution]Air et son projet Projetmmo.fr, 8 mai 2007 

Contact : projetmmo@gmail.com

Auteur :
Pierre-Yves Ricau (pierre-yves.ricau@insa-rouen.fr)

Ce programme informatique sert  gnrer la liste des images  dessiner.

Ce logiciel est rgi par la licence CeCILL v2 soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffuse par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,   l'utilisation,   la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant 
donn sa spcificit de logiciel libre, qui peut le rendre complexe  
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invits  charger  et  tester  l'adquation  du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 l'utiliser et l'exploiter dans les mmes conditions de scurit. 

Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accept les
termes.
*/
/* ********************************************************************* */
/*Fichiers d'entte inclus*/
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

/*Nombre maximum de caractres pour les types de gographie*/
#define MAX_CHAR 100

/* ********************************************************************* */
/*main : fonction principale*/
int main(int argc, char **argv)
{

    /* ************Dclaration des variables************ */

    /*Nom des fichiers (note : maximum 100 caractres)*/
    char nomRelief[100], nomTemperature[100], nomVegetation[100], nomResultat[100];

    /*Tableaux de chanes de caractres*/
    char **listeRelief = NULL, **listeTemperature = NULL, **listeVegetation = NULL;

    /*Fichiers du programmes*/
    FILE *config, *cfgRelief, *cfgTemperature, *cfgVegetation, *fichier;

    /*Variables utiles*/
    int i, j, k, nbRelief, nbTemperature, nbVegetation, valeur;

    /* ************Initialisation*********************** */

    /* Chargement de la configuration */
    config = fopen("configListe.txt","r");
    fscanf(config, "%s", nomRelief);
    fscanf(config, "%s", nomTemperature);
    fscanf(config, "%s", nomVegetation);
    fscanf(config, "%s", nomResultat);

    /*Chargement des configs de gographie*/
    cfgRelief = fopen(nomRelief,"r");
    fscanf(cfgRelief, "%d", &nbRelief);

    cfgTemperature = fopen(nomTemperature,"r");
    fscanf(cfgTemperature, "%d", &nbTemperature);

    cfgVegetation = fopen(nomVegetation,"r");
    fscanf(cfgVegetation, "%d", &nbVegetation);


    /*Cration et initialisation des tableaux*/
    listeRelief=(char**)malloc(nbRelief*sizeof(char*));
    for (i=0; i<nbRelief; i++)
        listeRelief[i]=(char*)malloc(MAX_CHAR*sizeof(char));
    for (i=0; i<nbRelief; i++)
        fscanf(cfgRelief, "%s", listeRelief[i]);

    listeTemperature=(char**)malloc(nbTemperature*sizeof(char*));
    for (i=0; i<nbTemperature; i++)
        listeTemperature[i]=(char*)malloc(MAX_CHAR*sizeof(char));
    for (i=0; i<nbTemperature; i++)
        fscanf(cfgTemperature, "%s", listeTemperature[i]);

    listeVegetation=(char**)malloc(nbVegetation*sizeof(char*));
    for (i=0; i<nbVegetation; i++)
        listeVegetation[i]=(char*)malloc(MAX_CHAR*sizeof(char));
    for (i=0; i<nbVegetation; i++)
        fscanf(cfgVegetation, "%s", listeVegetation[i]);

    /*Cration du fichier texte final*/
    fichier = fopen(nomResultat,"w");

    /* ************Traitement*************************** */

    for (i=0; i<nbRelief; i++)
        for (j=0; j<nbTemperature; j++)
            for (k=0; k<nbVegetation; k++)
            {
                valeur=i*nbTemperature*nbVegetation + j*nbVegetation + k;
                fprintf(fichier, "%d : %s, %s, %s.\n",valeur, listeRelief[i], listeTemperature[j], listeVegetation[k]);
            }

    /* ************Nettoyage de la mmoire************** */

    /*On ferme les fichiers*/
    fclose(config);
    fclose(cfgRelief);
    fclose(cfgTemperature);
    fclose(cfgVegetation);
    fclose(fichier);

    /*On libre les tableaux*/
    for (i=0; i<nbRelief; i++)
        free(listeRelief[i]);
    free(listeRelief);

    for (i=0; i<nbTemperature; i++)
        free(listeTemperature[i]);
    free(listeTemperature);

    for (i=0; i<nbVegetation; i++)
        free(listeVegetation[i]);
    free(listeVegetation);

    return EXIT_SUCCESS;
}
