/*
Copyright Rev'[evolution]Air et son projet Projetmmo.fr, 2007

Contact : projetmmo@gmail.com

Auteur :
Pierre-Yves Ricau (pierre-yves.ricau@insa-rouen.fr)

Ce programme informatique sert  convertir des images en niveau de gris
en une carte de jeu utilisable.

Ce logiciel est rgi par la licence CeCILL v2 soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffuse par le CEA, le CNRS et l'INRIA
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilit au code source et des droits de copie,
de modification et de redistribution accords par cette licence, il n'est
offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
seule une responsabilit restreinte pse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concdants successifs.

A cet gard  l'attention de l'utilisateur est attire sur les risques
associs au chargement,   l'utilisation,   la modification et/ou au
dveloppement et  la reproduction du logiciel par l'utilisateur tant
donn sa spcificit de logiciel libre, qui peut le rendre complexe 
manipuler et qui le rserve donc  des dveloppeurs et des professionnels
avertis possdant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invits  charger  et  tester  l'adquation  du
logiciel  leurs besoins dans des conditions permettant d'assurer la
scurit de leurs systmes et ou de leurs donnes et, plus gnralement,
 l'utiliser et l'exploiter dans les mmes conditions de scurit.

Le fait que vous puissiez accder  cet en-tte signifie que vous avez
pris connaissance de la licence CeCILL v2, et que vous en avez accept les
termes.
*/
/* ********************************************************************* */
/*Fichiers d'entte inclus*/
#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <unistd.h>
#include <time.h>

/* ********************************************************************* */
/*Prototypes*/
/*Les commentaires sont dans les corps de fonction*/

/*imageEnTableau : permet de transformer une image en un tableau*/
void imageEnTableau(SDL_Surface *surface, int** tableau, int largeur, int hauteur, int valeurMax);
/*creerMap : Cr toutes les images reprsentant la map*/
void creerMap(int **tabTotal, int largeurMap, int hauteurMap, int largeurCase, int hauteurCase, char extensionImg[], char prefixeImgResultat[], int nbTotal, int largeurZone, int hauteurZone, int largeurApercu, int hauteurApercu);
/*remplirZone : Remplie une image reprsentant une zone avec des tuiles*/
void remplirZone(int **tabTotal, int xDebut, int yDebut, int largeurZone, int hauteurZone, int largeurCase, int hauteurCase, SDL_Surface *zone, SDL_Surface **cases);
/*remplirApercu : Cr un apercu de la carte entire  partir des diffrentes zone*/
void remplirApercu(SDL_Surface *apercu, SDL_Surface *zone, int xDebut, int yDebut, int largeur, int hauteur);

/*Fonctions utilises par les fonctions de modification d'image*/
/*obtenirPixel : permet de rcuprer la couleur d'un pixel*/
Uint32 obtenirPixel(SDL_Surface *surface, int x, int y);
/*definirPixel : permet de modifier la couleur d'un pixel*/
void definirPixel(SDL_Surface *surface, int x, int y, Uint32 pixel);

/* ********************************************************************* */
/*main : fonction principale*/
int main(int argc, char **argv)
{

    /* ************Dclaration des variables************ */

    /*L'image  traiter*/
    SDL_Surface *imgRelief = NULL, *imgTemperature = NULL, *imgVegetation = NULL;

    /*Tableau intermdiaire que l'on va crire dans un fichier*/
    int **tabRelief = NULL, **tabTemperature = NULL, **tabVegetation = NULL, **tabTotal = NULL;

    /*Variables de traitement*/
    int i, largeurMap, hauteurMap, x, y, nbRelief, nbTemperature, nbVegetation, nbTotal, valeur, largeurCase, hauteurCase, largeurZone, hauteurZone, largeurApercu, hauteurApercu;

    /*Chanes de caractres (note : maximum 100 caractres)*/
    char nomImgRelief[100], nomImgTemperature[100], nomImgVegetation[100], nomResultat[100], nomRelief[100], nomTemperature[100], nomVegetation[100], extensionImg[10], prefixeImgResultat[10];

    /*Fichiers du programmes*/
    FILE *config, *cfgListe, *cfgRelief, *cfgTemperature, *cfgVegetation, *fichier;

    /* ************Initialisation*********************** */

    /* Chargement de la configuration */
    config = fopen("configMap.txt","r");
    fscanf(config, "%s", nomImgRelief);
    fscanf(config, "%s", nomImgTemperature);
    fscanf(config, "%s", nomImgVegetation);
    fscanf(config, "%s", nomResultat);
    fscanf(config, "%d", &largeurMap);
    fscanf(config, "%d", &hauteurMap);
    fscanf(config, "%s", extensionImg);
    fscanf(config, "%d", &largeurCase);
    fscanf(config, "%d", &hauteurCase);
    fscanf(config, "%s", prefixeImgResultat);
    fscanf(config, "%d", &largeurZone);
    fscanf(config, "%d", &hauteurZone);
    fscanf(config, "%d", &largeurApercu);
    fscanf(config, "%d", &hauteurApercu);
    fclose(config);

    cfgListe = fopen("configListe.txt","r");
    fscanf(cfgListe, "%s", nomRelief);
    fscanf(cfgListe, "%s", nomTemperature);
    fscanf(cfgListe, "%s", nomVegetation);
    fclose(cfgListe);

    /*Chargement des configs de gographie*/
    cfgRelief = fopen(nomRelief,"r");
    fscanf(cfgRelief, "%d", &nbRelief);
    fclose(cfgRelief);

    cfgTemperature = fopen(nomTemperature,"r");
    fscanf(cfgTemperature, "%d", &nbTemperature);
    fclose(cfgTemperature);

    cfgVegetation = fopen(nomVegetation,"r");
    fscanf(cfgVegetation, "%d", &nbVegetation);
    fclose(cfgVegetation);

    /*Cration des tableaux*/
    tabRelief=(int**)malloc(largeurMap*sizeof(int*));
    for (i=0; i<largeurMap; i++)
        tabRelief[i]=(int*)malloc(hauteurMap*sizeof(int));

    tabTemperature=(int**)malloc(largeurMap*sizeof(int*));
    for (i=0; i<largeurMap; i++)
        tabTemperature[i]=(int*)malloc(hauteurMap*sizeof(int));

    tabVegetation=(int**)malloc(largeurMap*sizeof(int*));
    for (i=0; i<largeurMap; i++)
        tabVegetation[i]=(int*)malloc(hauteurMap*sizeof(int));

    tabTotal=(int**)malloc(largeurMap*sizeof(int*));
    for (i=0; i<largeurMap; i++)
        tabTotal[i]=(int*)malloc(hauteurMap*sizeof(int));

    /*Initialisation de la SDL*/
    SDL_Init(SDL_INIT_VIDEO);

    /*Chargement des images*/
    imgRelief = IMG_Load(nomImgRelief);
    imgTemperature = IMG_Load(nomImgTemperature);
    imgVegetation = IMG_Load(nomImgVegetation);

    /*Cration du fichier texte final*/
    fichier = fopen(nomResultat,"w");

    /* ************Traitement*************************** */

    /*Transformation des images en tableaux*/
    imageEnTableau(imgRelief, tabRelief, largeurMap, hauteurMap, nbRelief-1);
    SDL_FreeSurface(imgRelief); /*On supprime l'image charge en mmoire*/

    imageEnTableau(imgTemperature, tabTemperature, largeurMap, hauteurMap, nbTemperature-1);
    SDL_FreeSurface(imgTemperature); /*On supprime l'image charge en mmoire*/

    imageEnTableau(imgVegetation, tabVegetation, largeurMap, hauteurMap, nbVegetation-1);
    SDL_FreeSurface(imgVegetation); /*On supprime l'image charge en mmoire*/

    /*Ecriture dans le tableau et dans le fichier*/
    for (y=0; y<hauteurMap; y++)
    {
        for (x=0; x<largeurMap; x++)
        {
            valeur = tabRelief[x][y]*nbTemperature*nbVegetation + tabTemperature[x][y]*nbVegetation + tabVegetation[x][y];
            tabTotal[x][y] = valeur;
            fprintf(fichier, "%d ",valeur);
        }
        fprintf(fichier,"\n");
    }
    /*On ferme le fichier de rsultat*/
    fclose(fichier);

    /*On libre les tableaux, inutiles dsormais*/
    for (i=0; i<largeurMap; i++)
    {
        free(tabRelief[i]);
        free(tabTemperature[i]);
        free(tabVegetation[i]);
    }
    free(tabRelief);
    free(tabTemperature);
    free(tabVegetation);

    /*On calcule le nombre de tuiles diffrentes*/
    nbTotal = nbRelief * nbTemperature * nbVegetation;

    /*On cr les fichiers graphiques reprsentant la map et on les remplit*/
    creerMap(tabTotal, largeurMap, hauteurMap, largeurCase, hauteurCase, extensionImg, prefixeImgResultat, nbTotal, largeurZone, hauteurZone, largeurApercu, hauteurApercu);

    /* ************Nettoyage final de la mmoire************** */

    /*On libre le tableau*/
    for (i=0; i<largeurMap; i++)
        free(tabTotal[i]);
    free(tabTotal);

    /*On quitte la SDL*/
    SDL_Quit();

    return EXIT_SUCCESS;

}

/* ********************************************************************* */
/*imageEnTableau : permet de transformer une image en un tableau
Paramtres d'entre/sortie :
SDL_Surface *surface : la surface  lire
int** tableau : le tableau  remplir
int largeur : la largeur du tableau
int hauteur : la hauteur du tableau
int valeurMax : la valeur maximale correspondant  255 dans l'image
*/
void imageEnTableau(SDL_Surface *surface, int** tableau, int largeur, int hauteur, int valeurMax)
{
    /*Dclaration des variables*/
    /*pixel stocke le code couleur d'un pixel*/
    Uint32 pixel;
    /*r,g,b,a vont stocker les composantes d'un pixel*/
    Uint8 r,g,b,a;
    /*Les coordonnes en x et en y dans le tableau*/
    int xTableau, yTableau;

    /*On bloque la surface pour pouvoir travailler dessus */
    SDL_LockSurface(surface);
    /*Double boucle pour parcourir l'intgralit du tableau.*/
    for (yTableau=0;yTableau<hauteur;yTableau++)
    {
        for (xTableau=0;xTableau<largeur;xTableau++)
        {
            /*On rcupre le code couleur du pixel correspondant  la case du tableau*/
            pixel=obtenirPixel(surface,(xTableau*surface->w)/largeur,(yTableau*surface->h)/hauteur);
            /*On extrait les composantes rouge, vert, bleu et alpha*/
            SDL_GetRGBA(pixel, surface->format, &r, &g, &b, &a);
            /*On rcupre la valeur en rouge que l'on met  l'chelle*/
            tableau[xTableau][yTableau]=(r*valeurMax)/255;
        }
    }
    /*On libre la surface, elle peut dsormais tre rutilise pour autre chose*/
    SDL_UnlockSurface(surface);
}


/* ********************************************************************* */
/*creerMap : Cr toutes les images reprsentant la map.
Paramtres d'entre/sortie :
int **tabTotal : Tableau contenant les numros de tuiles de chaque case de la map
int largeurMap : Nombre de cases en largeur de la map
int hauteurMap : Nombre de cases en hauteur de la map
int largeurCase : Nombre de pixels en largeur pour une case
int hauteurCase : Nombre de pixels en hauteur pour une case
char extensionImg[] : Format d'extension des tuiles (png, bmp, jpg, ...)
chat prefixeImgResultat[] : Prefixe des images produites en rsultat.
int nbTotal : Nombre de type de tuiles diffrents.
int largeurZone : Nombre de cases en largeur d'une zone (une zone = 1 fichier image)
int hauteurZone  : Nombre de cases en hauteur d'une zone (une zone = 1 fichier image)
int largeurApercu : Largeur en pixels de l'aperu de la carte entire
int hauteurApecu : Hauteur en pixels de l'aperu de la carte entire
*/
void creerMap(int **tabTotal, int largeurMap, int hauteurMap, int largeurCase, int hauteurCase, char extensionImg[], char prefixeImgResultat[], int nbTotal, int largeurZone, int hauteurZone, int largeurApercu, int hauteurApercu)
{
    /*Dclaration des variables*/
    int i, largeurPixelZone, hauteurPixelZone, x, y, largeurPixelZoneApercu, hauteurPixelZoneApercu;
    char buffer[20];
    SDL_Surface *zone, *apercu, **tuiles;

    /*Chargement des tuiles  dessiner sur la carte*/
    tuiles = (SDL_Surface**)malloc(nbTotal*sizeof(SDL_Surface*));
    for (i=0; i<nbTotal; i++)
    {
        sprintf(buffer,"tuiles/%d.%s",i,extensionImg);
        tuiles[i]=IMG_Load(buffer);
    }


    largeurPixelZone = largeurZone*largeurCase;
    hauteurPixelZone = hauteurZone*hauteurCase;

    /*Cration de l'image pour le dessin de l'aperu*/
    apercu = SDL_CreateRGBSurface(SDL_HWSURFACE, largeurApercu, hauteurApercu, 32, 0, 0, 0, 0);

    /*Calcul des dimensions en pixel d'une zone dans l'aperu*/
    largeurPixelZoneApercu=(apercu->w*largeurZone)/largeurMap;
    hauteurPixelZoneApercu=(apercu->h*hauteurZone)/hauteurMap;

    /*On cr une surface vide pour la zone*/
    zone = SDL_CreateRGBSurface(SDL_HWSURFACE, largeurPixelZone, hauteurPixelZone, 32, 0, 0, 0, 0);

    /*On parcours la map de zone en zone*/
    for (x=0; x<largeurMap; x+=largeurZone)
        for (y=0; y<hauteurMap; y+=hauteurZone)
        {
            /*On dessine la zone*/
            remplirZone(tabTotal, x, y, largeurZone, hauteurZone, largeurCase, hauteurCase, zone, tuiles);
            /*On cr le nom pour l'image de la zone*/
            sprintf(buffer,"map/%s_%d_%d.bmp",prefixeImgResultat,x,y);
            /*On ajoute la zone dans l'aperu*/
            remplirApercu(apercu, zone, (x*largeurPixelZoneApercu)/largeurZone, (y*hauteurPixelZoneApercu)/hauteurZone, largeurPixelZoneApercu, hauteurPixelZoneApercu);
            /*On enregistre l'image de la zone*/
            SDL_SaveBMP(zone, buffer);
        }
    /*On supprime l'image en mmoire*/
    SDL_FreeSurface(zone);
    /*On cr le  nom pour l'image de l'aperu*/
    sprintf(buffer,"map/%s_apercu.bmp",prefixeImgResultat);
    /*On enregistre l'image de l'aperu*/
    SDL_SaveBMP(apercu, buffer);
    /*On supprime l'image en mmoire*/
    SDL_FreeSurface(apercu);
}

/* ********************************************************************* */
/*remplirZone : Remplie une image reprsentant une zone avec des tuiles.
Paramtres d'entre/sortie :
int **tabTotal : Tableau contenant les numros de tuiles de chaque case de la map
int xDebut : Coordonne en X dans le tableau tabTotal de la zone  dessiner
int yDebut : Coordonne en Y dans le tableau tabTotal de la zone  dessiner
int largeurZone : Nombre de cases en largeur d'une zone (une zone = 1 fichier image)
int hauteurZone  : Nombre de cases en hauteur d'une zone (une zone = 1 fichier image)
int largeurCase : Nombre de pixels en largeur pour une case
int hauteurCase : Nombre de pixels en hauteur pour une case
SDL_Surface *zone : Zone  dessiner
SDL_Surface **cases : Tableau d'images, qui sont les tuiles
*/
void remplirZone(int **tabTotal, int xDebut, int yDebut, int largeurZone, int hauteurZone, int largeurCase, int hauteurCase, SDL_Surface *zone, SDL_Surface **cases)
{
    /*Dclaration des variables*/
    int x, y;
    SDL_Rect position;

    /*On parcours la zone case par case*/
    for (y=0; y<hauteurZone; y++)
        for (x=largeurZone-1; x>=0; x--)
        {
            /* On calcule les coordonnes en pixels d'une case dans la zone*/
            position.x=x*largeurCase;
            position.y=(y+1)*hauteurCase - cases[tabTotal[x+xDebut][y+yDebut]]->h;
            /*On dessine la case dans la zone*/
            SDL_BlitSurface(cases[tabTotal[x+xDebut][y+yDebut]], NULL, zone, &position);
        }
}

/* ********************************************************************* */
/*remplirApercu : Cr un apercu de la carte entire  partir des diffrentes zone.
Paramtres d'entre/sortie :
SDL_Surface *apercu : L'image d'aperu  remplir
SDL_Surface *zone : La zone a recopier en plus petit
int xDebut : Coordonne en X en pixel du dbut de la zone  dessiner
int yDebut : Coordonne en Y en pixel du dbut de la zone  dessiner
int largeur : Nombre de pixels en largeur d'une zone dans l'aperu
int hauteur  : Nombre de pixels en hauteur d'une zone dans l'aperu
*/
void remplirApercu(SDL_Surface *apercu, SDL_Surface *zone, int xDebut, int yDebut, int largeur, int hauteur)
{
    /*Dclaration des variables*/
    int x,y;
    Uint32 pixel;

    /*On bloque les surfaces pour pouvoir travailler dessus*/
    SDL_LockSurface(apercu);
    SDL_LockSurface(zone);
    /*Double boucle pour parcourir l'intgralit des images*/
    for (y=0;y<hauteur;y++)
        for (x=0;x<largeur;x++)
        {
            /*On rcupre le code couleur du pixel.*/
            pixel=obtenirPixel(zone,(x*zone->w)/largeur,(y*zone->h)/hauteur);
            /*On injecte le code couleur pixel dans le pixel correspondant*/
            definirPixel(apercu, xDebut+x, yDebut+y, pixel);
        }
    /*On dbloque les surfaces*/
    SDL_UnlockSurface(zone);
    SDL_UnlockSurface(apercu);
}

/* ********************************************************************* */
/*obtenirPixel : permet de rcuprer la couleur d'un pixel
Paramtres d'entre/sortie :
SDL_Surface *surface : la surface sur laquelle on va rcuprer la couleur d'un pixel
int x : la coordonne en x du pixel  rcuprer
int y : la coordonne en y du pixel  rcuprer

Uint32 retour : la fonction renvoie le pixel aux coordonnes (x,y) dans la surface
*/
Uint32 obtenirPixel(SDL_Surface *surface, int x, int y)
{
    /*nbOctetsParPixel reprsente le nombre d'octets utiliss pour stocker un pixel.
    En multipliant ce nombre d'octets par 8 (un octet = 8 bits), on obtient la profondeur de couleur
    de l'image : 8, 16, 24 ou 32 bits.*/
    int nbOctetsParPixel = surface->format->BytesPerPixel;
    /* Ici p est l'adresse du pixel que l'on veut connaitre */
    /*surface->pixels contient l'adresse du premier pixel de l'image*/
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * nbOctetsParPixel;

    /*Gestion diffrente suivant le nombre d'octets par pixel de l'image*/
    switch(nbOctetsParPixel)
    {
        case 1:
            return *p;

        case 2:
            return *(Uint16 *)p;

        case 3:
            /*Suivant l'architecture de la machine*/
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
                return p[0] << 16 | p[1] << 8 | p[2];
            else
                return p[0] | p[1] << 8 | p[2] << 16;

        case 4:
            return *(Uint32 *)p;

        /*Ne devrait pas arriver, mais vite les erreurs*/
        default:
            return 0;
    }
}

/* ********************************************************************* */
/*definirPixel : permet de modifier la couleur d'un pixel
Ce code n'est pas comment car trop complexe.
Paramtres d'entre/sortie :
SDL_Surface *surface : la surface sur laquelle on va modifier la couleur d'un pixel
int x : la coordonne en x du pixel  modifier
int y : la coordonne en y du pixel  modifier
Uint32 pixel : le pixel  insrer
*/
void definirPixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    /*nbOctetsParPixel reprsente le nombre d'octets utiliss pour stocker un pixel.
    En multipliant ce nombre d'octets par 8 (un octet = 8 bits), on obtient la profondeur de couleur
    de l'image : 8, 16, 24 ou 32 bits.*/
    int nbOctetsParPixel = surface->format->BytesPerPixel;
    /*Ici p est l'adresse du pixel que l'on veut modifier*/
    /*surface->pixels contient l'adresse du premier pixel de l'image*/
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * nbOctetsParPixel;

    /*Gestion diffrente suivant le nombre d'octets par pixel de l'image*/
    switch(nbOctetsParPixel)
    {
        case 1:
            *p = pixel;
            break;

        case 2:
            *(Uint16 *)p = pixel;
            break;

        case 3:
            /*Suivant l'architecture de la machine*/
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            {
                p[0] = (pixel >> 16) & 0xff;
                p[1] = (pixel >> 8) & 0xff;
                p[2] = pixel & 0xff;
            }
            else
            {
                p[0] = pixel & 0xff;
                p[1] = (pixel >> 8) & 0xff;
                p[2] = (pixel >> 16) & 0xff;
            }
            break;

        case 4:
            *(Uint32 *)p = pixel;
            break;
    }
}
